<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs [forceReload]="tenantId"></app-breadcrumbs>

  <div
    id="userManagementTitle"
    class="h3"
    [innerText]="messages.USERS_MANAGEMENT">
  </div>

  <!-- Header -->

  <div class="mt-3 mb-2 d-flex align-items-start">

    <button
      ls-button
      class="me-2"
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.CREATE_USER"
      (click)="onCreateUserClicked()">
    </button>

    <app-search-bar
      class="search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="messages.TENANT_SEARCH_USER">
    </app-search-bar>

    <span class="flex-grow-1"></span>
    <span
      class="p-1 px-2"
      [innerText]="commonMessages.PAGINATION_SIZE_LABEL">
    </span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="refreshUserList(true)">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="userManagementTitle"
    class="bg-white table table-fixed table-striped table-borderless border shadow-sm w-100 table-text-overflow">
    <thead class="border">
      <tr>
        <th
          *ngIf="userPreferences.showAdminIds"
          scope="col"
          class="col-id-fixed-size"
          (click)="onRowOrderClicked(sortByEnum.Id)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th
          class="col"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.LastName)">
          <fa-icon
            class="{{ sortBy === sortByEnum.LastName ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.LAST_NAME }}
        </th>
        <th
          class="col"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.FirstName)">
          <fa-icon
            class="{{ sortBy === sortByEnum.FirstName ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.FIRST_NAME }}
        </th>
        <th
          scope="col"
          class="col"
          (click)="onRowOrderClicked(sortByEnum.Username)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Username ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.USERNAME }}
        </th>
        <th
          scope="col"
          class="col"
          (click)="onRowOrderClicked(sortByEnum.Email)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Email ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.MAIL }}
        </th>
        <th
          scope="col"
          class="col-buttons-fixed-size"
          [ngClass]="{'text-center': show52Features}"
          [innerText]="commonMessages.INFOS">
        </th>
        <th
          scope="col"
          class="col-buttons-fixed-size"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let user of userList">
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="user.id | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="user.lastName | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="user.firstName | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="user.userName | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="user.email">
          </span>
        </td>
        <td>
          <fa-icon
            class="{{ user.isLdapSynchronized ? 'visible' : 'invisible' }}"
            [ngbTooltip]="messages.LDAP_USER_TOOLTIP"
            [openDelay]="300"
            [icon]="ldapUserIcon"
            [fixedWidth]="true"
            size="lg">
          </fa-icon>

          <fa-icon
            *ngIf="show52Features"
            class="{{ user.isFromIdentityProvider ? 'visible' : 'invisible' }}"
            [ngbTooltip]="messages.IDP_USER_TOOLTIP"
            [openDelay]="300"
            [icon]="idpUserIcon"
            [fixedWidth]="true"
            size="lg">
          </fa-icon>

          <fa-icon
            *ngIf="user.privilege !== privilegeEnum.None"
            class="ms-2"
            [ngbTooltip]="user.privilege | privilegeName"
            [openDelay]="300"
            [icon]="user.privilege | privilegeIcon"
            [fixedWidth]="true"
            size="lg">
          </fa-icon>
        </td>
        <td>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [disabled]="isGreaterAdmin(user)"
            [ngbTooltip]="messages.ONLY_AN_ADMIN_CAN_EDIT_AN_ADMIN"
            [disableTooltip]="!isGreaterAdmin(user)"
            [title]="commonMessages.EDIT"
            (click)="onEditUserButtonClicked(user)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            [disabled]="(firstTotal <= 1) || isGreaterAdmin(user)"
            [ngbTooltip]="messages.ONLY_AN_ADMIN_CAN_EDIT_AN_ADMIN"
            [disableTooltip]="!isGreaterAdmin(user)"
            [title]="commonMessages.UNLINK"
            (click)="onUnlinkUserButtonClicked(user)">
            <fa-icon [icon]="unlinkIcon"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="userList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_USER_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshUserList(false)">
  </ngb-pagination>

</div>
